/// @cond EO_CXX_EO_IMPL

inline void elm::ctxpopup::dismiss() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_dismiss());
}

inline void elm::ctxpopup::clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_clear());
}

inline ::elm::widget_item elm::ctxpopup::item_append(::efl::eina::string_view label_, ::evas::object icon_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_item_append(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::ctxpopup::item_prepend(::efl::eina::string_view label_, ::evas::object icon_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_item_prepend(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::ctxpopup::horizontal_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_horizontal_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::ctxpopup::horizontal_set(bool horizontal_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_horizontal_set(::efl::eolian::to_c(horizontal_)));
}

inline bool elm::ctxpopup::auto_hide_disabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_auto_hide_disabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::ctxpopup::auto_hide_disabled_set(bool disabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_auto_hide_disabled_set(::efl::eolian::to_c(disabled_)));
}

inline ::evas::object elm::ctxpopup::hover_parent_get() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_hover_parent_get());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::ctxpopup::hover_parent_set(::evas::object parent_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_hover_parent_set(::efl::eolian::to_c(parent_)));
}

inline void elm::ctxpopup::direction_priority_get(Elm_Ctxpopup_Direction* first_, Elm_Ctxpopup_Direction* second_, Elm_Ctxpopup_Direction* third_, Elm_Ctxpopup_Direction* fourth_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_direction_priority_get(first_, second_, third_, fourth_));
}

inline void elm::ctxpopup::direction_priority_set(Elm_Ctxpopup_Direction first_, Elm_Ctxpopup_Direction second_, Elm_Ctxpopup_Direction third_, Elm_Ctxpopup_Direction fourth_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_direction_priority_set(first_, second_, third_, fourth_));
}

inline Elm_Ctxpopup_Direction elm::ctxpopup::direction_get() const
{
   Elm_Ctxpopup_Direction _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_direction_get());
   return _tmp_ret;
}

inline ::efl::eina::crange_list< Elm_Object_Item * > elm::ctxpopup::items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< Elm_Object_Item * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::elm::widget_item elm::ctxpopup::first_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_first_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::ctxpopup::last_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_last_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::ctxpopup::dismiss() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_dismiss());
}

inline void eo_cxx::elm::ctxpopup::clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_clear());
}

inline ::elm::widget_item eo_cxx::elm::ctxpopup::item_append(::efl::eina::string_view label_, ::evas::object icon_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_item_append(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::ctxpopup::item_prepend(::efl::eina::string_view label_, ::evas::object icon_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_item_prepend(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::ctxpopup::horizontal_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_horizontal_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::ctxpopup::horizontal_set(bool horizontal_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_horizontal_set(::efl::eolian::to_c(horizontal_)));
}

inline bool eo_cxx::elm::ctxpopup::auto_hide_disabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_auto_hide_disabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::ctxpopup::auto_hide_disabled_set(bool disabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_auto_hide_disabled_set(::efl::eolian::to_c(disabled_)));
}

inline ::evas::object eo_cxx::elm::ctxpopup::hover_parent_get() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_hover_parent_get());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::ctxpopup::hover_parent_set(::evas::object parent_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_hover_parent_set(::efl::eolian::to_c(parent_)));
}

inline void eo_cxx::elm::ctxpopup::direction_priority_get(Elm_Ctxpopup_Direction* first_, Elm_Ctxpopup_Direction* second_, Elm_Ctxpopup_Direction* third_, Elm_Ctxpopup_Direction* fourth_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_direction_priority_get(first_, second_, third_, fourth_));
}

inline void eo_cxx::elm::ctxpopup::direction_priority_set(Elm_Ctxpopup_Direction first_, Elm_Ctxpopup_Direction second_, Elm_Ctxpopup_Direction third_, Elm_Ctxpopup_Direction fourth_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_ctxpopup_direction_priority_set(first_, second_, third_, fourth_));
}

inline Elm_Ctxpopup_Direction eo_cxx::elm::ctxpopup::direction_get() const
{
   Elm_Ctxpopup_Direction _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_direction_get());
   return _tmp_ret;
}

inline ::efl::eina::crange_list< Elm_Object_Item * > eo_cxx::elm::ctxpopup::items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< Elm_Object_Item * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::ctxpopup::first_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_first_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::ctxpopup::last_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_last_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::elm::ctxpopup::operator ::elm::ctxpopup() const
{
   return *static_cast<::elm::ctxpopup const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::ctxpopup::operator ::elm::ctxpopup&()
{
   return *static_cast<::elm::ctxpopup*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::ctxpopup::operator ::elm::ctxpopup const&() const
{
   return *static_cast<::elm::ctxpopup const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_ctxpopup_dismiss_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->dismiss();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_ctxpopup_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_ctxpopup_item_append_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * label_, Evas_Object * icon_, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_append(::efl::eolian::to_cxx<::efl::eina::string_view>(label_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(icon_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_ctxpopup_item_prepend_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * label_, Evas_Object * icon_, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_prepend(::efl::eolian::to_cxx<::efl::eina::string_view>(label_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::evas::object>(icon_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_ctxpopup_horizontal_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->horizontal_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_ctxpopup_horizontal_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool horizontal_)
{
   try
      {
         static_cast<T*>(self->this_)->horizontal_set(::efl::eolian::to_cxx<bool>(horizontal_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_ctxpopup_auto_hide_disabled_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->auto_hide_disabled_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_ctxpopup_auto_hide_disabled_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool disabled_)
{
   try
      {
         static_cast<T*>(self->this_)->auto_hide_disabled_set(::efl::eolian::to_cxx<bool>(disabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::evas::object elm_ctxpopup_hover_parent_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->hover_parent_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Object * _tmp_ret{};
         return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_ctxpopup_hover_parent_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * parent_)
{
   try
      {
         static_cast<T*>(self->this_)->hover_parent_set(::efl::eolian::to_cxx<::evas::object>(parent_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_ctxpopup_direction_priority_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Ctxpopup_Direction* first_, Elm_Ctxpopup_Direction* second_, Elm_Ctxpopup_Direction* third_, Elm_Ctxpopup_Direction* fourth_)
{
   try
      {
         static_cast<T*>(self->this_)->direction_priority_get(first_, second_, third_, fourth_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_ctxpopup_direction_priority_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Ctxpopup_Direction first_, Elm_Ctxpopup_Direction second_, Elm_Ctxpopup_Direction third_, Elm_Ctxpopup_Direction fourth_)
{
   try
      {
         static_cast<T*>(self->this_)->direction_priority_set(first_, second_, third_, fourth_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Ctxpopup_Direction elm_ctxpopup_direction_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->direction_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Ctxpopup_Direction _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
::efl::eina::crange_list< Elm_Object_Item * > elm_ctxpopup_items_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->items_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< Elm_Object_Item * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_ctxpopup_first_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->first_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_ctxpopup_last_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->last_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::ctxpopup >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
   {
      virtual void dismiss()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_dismiss());
      }

      virtual void clear()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_clear());
      }

      virtual ::elm::widget_item item_append(::efl::eina::string_view label_, ::evas::object icon_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_item_append(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_prepend(::efl::eina::string_view label_, ::evas::object icon_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_item_prepend(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_horizontal_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void horizontal_set(bool horizontal_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_horizontal_set(::efl::eolian::to_c(horizontal_)));
      }

      virtual bool auto_hide_disabled_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_auto_hide_disabled_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void auto_hide_disabled_set(bool disabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_auto_hide_disabled_set(::efl::eolian::to_c(disabled_)));
      }

      virtual ::evas::object hover_parent_get()
      {
         Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_hover_parent_get());
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void hover_parent_set(::evas::object parent_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_hover_parent_set(::efl::eolian::to_c(parent_)));
      }

      virtual void direction_priority_get(Elm_Ctxpopup_Direction* first_, Elm_Ctxpopup_Direction* second_, Elm_Ctxpopup_Direction* third_, Elm_Ctxpopup_Direction* fourth_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_direction_priority_get(first_, second_, third_, fourth_));
      }

      virtual void direction_priority_set(Elm_Ctxpopup_Direction first_, Elm_Ctxpopup_Direction second_, Elm_Ctxpopup_Direction third_, Elm_Ctxpopup_Direction fourth_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_direction_priority_set(first_, second_, third_, fourth_));
      }

      virtual Elm_Ctxpopup_Direction direction_get()
      {
         Elm_Ctxpopup_Direction _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_direction_get());
            return _tmp_ret;
      }

      virtual ::efl::eina::crange_list< Elm_Object_Item * > items_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_items_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< Elm_Object_Item * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual ::elm::widget_item first_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_first_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item last_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_last_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::ctxpopup >
{
   static constexpr int value = 
#if defined(CTXPOPUP_PROTECTED) && defined(CTXPOPUP_BETA)
      16
#elif defined(CTXPOPUP_PROTECTED)
      16
#elif defined(CTXPOPUP_BETA)
      16
#else
      16
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::ctxpopup>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_dismiss_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_dismiss);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_item_append_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_item_append);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_item_prepend_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_item_prepend);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_horizontal_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_horizontal_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_horizontal_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_horizontal_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_auto_hide_disabled_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_auto_hide_disabled_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_auto_hide_disabled_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_auto_hide_disabled_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_hover_parent_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_hover_parent_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_hover_parent_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_hover_parent_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_direction_priority_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_direction_priority_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_direction_priority_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_direction_priority_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_direction_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_direction_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_items_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_items_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_first_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_first_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_ctxpopup_last_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_last_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::ctxpopup >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::ctxpopup >::value + operation_description_class_size<::elm::layout>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::ctxpopup>)
{
   return (ELM_CTXPOPUP_CLASS);
}

} } }

/// @endcond

